blob: 75eb210eea4ef9eb0ca0b24ebf0bb993d54f1d90 [file] [log] [blame]
Vincent Driessenc3607ac2010-02-05 19:53:45 +01001#
2# git-flow -- A collection of Git extensions to provide high-level
3# repository operations for Vincent Driessen's branching model.
4#
5# Original blog post presenting this model is found at:
Vincent Driessenddb350b2010-07-09 09:42:09 +02006# http://nvie.com/git-model
Vincent Driessenc3607ac2010-02-05 19:53:45 +01007#
8# Feel free to contribute to this project at:
9# http://github.com/nvie/gitflow
10#
Vincent Driessend72acba2010-04-04 16:10:17 +020011# Copyright 2010 Vincent Driessen. All rights reserved.
12#
13# Redistribution and use in source and binary forms, with or without
14# modification, are permitted provided that the following conditions are met:
15#
16# 1. Redistributions of source code must retain the above copyright notice,
17# this list of conditions and the following disclaimer.
18#
19# 2. Redistributions in binary form must reproduce the above copyright
20# notice, this list of conditions and the following disclaimer in the
21# documentation and/or other materials provided with the distribution.
22#
23# THIS SOFTWARE IS PROVIDED BY VINCENT DRIESSEN ``AS IS'' AND ANY EXPRESS OR
24# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
25# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
26# EVENT SHALL VINCENT DRIESSEN OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
27# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
28# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
29# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
30# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
31# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
32# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
33#
34# The views and conclusions contained in the software and documentation are
35# those of the authors and should not be interpreted as representing official
36# policies, either expressed or implied, of Vincent Driessen.
Vincent Driessenc3607ac2010-02-05 19:53:45 +010037#
38
Vincent Driessen7832d6e2010-02-21 21:31:03 +010039#
40# Common functionality
41#
42
Vincent Driessenc3607ac2010-02-05 19:53:45 +010043# shell output
44warn() { echo "$@" >&2; }
45die() { warn "$@"; exit 1; }
46
Vincent Driessen1b471a62011-02-04 08:25:38 +010047escape() {
48 echo "$1" | sed 's/\([\.\+\$\*]\)/\\\1/g'
49}
50
Vincent Driessenc3607ac2010-02-05 19:53:45 +010051# set logic
52has() {
Vincent Driessenf46e2902010-02-15 23:01:52 +010053 local item=$1; shift
Vincent Driessen1b471a62011-02-04 08:25:38 +010054 echo " $@ " | grep -q " $(escape $item) "
Vincent Driessenc3607ac2010-02-05 19:53:45 +010055}
56
57# basic math
58min() { [ "$1" -le "$2" ] && echo "$1" || echo "$2"; }
59max() { [ "$1" -ge "$2" ] && echo "$1" || echo "$2"; }
60
61# basic string matching
62startswith() { [ "$1" != "${1#$2}" ]; }
Vincent Driessene0d8af32010-02-22 12:21:36 +010063endswith() { [ "$1" != "${1%$2}" ]; }
Vincent Driessenc3607ac2010-02-05 19:53:45 +010064
65# convenience functions for checking shFlags flags
Vincent Driessenf46e2902010-02-15 23:01:52 +010066flag() { local FLAG; eval FLAG='$FLAGS_'$1; [ $FLAG -eq $FLAGS_TRUE ]; }
67noflag() { local FLAG; eval FLAG='$FLAGS_'$1; [ $FLAG -ne $FLAGS_TRUE ]; }
Vincent Driessenc3607ac2010-02-05 19:53:45 +010068
69#
70# Git specific common functionality
71#
72
Adam Gibbinscf3da5a2010-08-22 19:13:34 +010073git_local_branches() { git branch --no-color | sed 's/^[* ] //'; }
74git_remote_branches() { git branch -r --no-color | sed 's/^[* ] //'; }
75git_all_branches() { ( git branch --no-color; git branch -r --no-color) | sed 's/^[* ] //'; }
Vincent Driessen7832d6e2010-02-21 21:31:03 +010076git_all_tags() { git tag; }
77
Vincent Driessen55c15532010-02-22 07:28:27 +010078git_current_branch() {
Adam Gibbinscf3da5a2010-08-22 19:13:34 +010079 git branch --no-color | grep '^\* ' | grep -v 'no branch' | sed 's/^* //g'
Vincent Driessen55c15532010-02-22 07:28:27 +010080}
81
82git_is_clean_working_tree() {
83 if ! git diff --no-ext-diff --ignore-submodules --quiet --exit-code; then
84 return 1
85 elif ! git diff-index --cached --quiet --ignore-submodules HEAD --; then
86 return 2
87 else
88 return 0
89 fi
90}
91
92git_repo_is_headless() {
93 ! git rev-parse --quiet --verify HEAD >/dev/null 2>&1
94}
95
96git_local_branch_exists() {
97 has $1 $(git_local_branches)
98}
99
100git_branch_exists() {
101 has $1 $(git_all_branches)
102}
103
104git_tag_exists() {
105 has $1 $(git_all_tags)
106}
107
108#
109# git_compare_branches()
110#
111# Tests whether branches and their "origin" counterparts have diverged and need
112# merging first. It returns error codes to provide more detail, like so:
113#
114# 0 Branch heads point to the same commit
115# 1 First given branch needs fast-forwarding
116# 2 Second given branch needs fast-forwarding
117# 3 Branch needs a real merge
118# 4 There is no merge base, i.e. the branches have no common ancestors
119#
120git_compare_branches() {
121 local commit1=$(git rev-parse "$1")
122 local commit2=$(git rev-parse "$2")
123 if [ "$commit1" != "$commit2" ]; then
124 local base=$(git merge-base "$commit1" "$commit2")
125 if [ $? -ne 0 ]; then
126 return 4
127 elif [ "$commit1" = "$base" ]; then
128 return 1
129 elif [ "$commit2" = "$base" ]; then
130 return 2
131 else
132 return 3
133 fi
134 else
135 return 0
136 fi
137}
138
139#
140# git_is_branch_merged_into()
141#
142# Checks whether branch $1 is succesfully merged into $2
143#
144git_is_branch_merged_into() {
145 local subject=$1
146 local base=$2
Brian St. Pierre5ff0b472010-11-03 16:40:58 -0400147 local all_merges="$(git branch --no-color --contains $subject | sed 's/^[* ] //')"
Vincent Driessen55c15532010-02-22 07:28:27 +0100148 has $base $all_merges
149}
150
151#
152# gitflow specific common functionality
153#
154
Vincent Driessenb25ab832010-02-20 11:21:23 +0100155# check if this repo has been inited for gitflow
156gitflow_has_master_configured() {
157 local master=$(git config --get gitflow.branch.master)
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100158 [ "$master" != "" ] && git_local_branch_exists "$master"
Vincent Driessenb25ab832010-02-20 11:21:23 +0100159}
160
161gitflow_has_develop_configured() {
162 local develop=$(git config --get gitflow.branch.develop)
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100163 [ "$develop" != "" ] && git_local_branch_exists "$develop"
Vincent Driessenb25ab832010-02-20 11:21:23 +0100164}
165
Vincent Driessen1d8bb0d2010-02-20 16:46:38 +0100166gitflow_has_prefixes_configured() {
167 git config --get gitflow.prefix.feature >/dev/null 2>&1 && \
168 git config --get gitflow.prefix.release >/dev/null 2>&1 && \
169 git config --get gitflow.prefix.hotfix >/dev/null 2>&1 && \
170 git config --get gitflow.prefix.support >/dev/null 2>&1 && \
171 git config --get gitflow.prefix.versiontag >/dev/null 2>&1
172}
173
Vincent Driessenb25ab832010-02-20 11:21:23 +0100174gitflow_is_initialized() {
Vincent Driessen1d8bb0d2010-02-20 16:46:38 +0100175 gitflow_has_master_configured && \
176 gitflow_has_develop_configured && \
177 [ "$(git config --get gitflow.branch.master)" != \
178 "$(git config --get gitflow.branch.develop)" ] && \
179 gitflow_has_prefixes_configured
Vincent Driessenb25ab832010-02-20 11:21:23 +0100180}
181
Vincent Driessend72e4ac2010-02-16 21:33:51 +0100182# loading settings that can be overridden using git config
183gitflow_load_settings() {
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100184 export DOT_GIT_DIR=$(git rev-parse --git-dir >/dev/null 2>&1)
Vincent Driessenc1598bf2010-02-20 16:52:48 +0100185 export MASTER_BRANCH=$(git config --get gitflow.branch.master)
186 export DEVELOP_BRANCH=$(git config --get gitflow.branch.develop)
Vincent Driessend72e4ac2010-02-16 21:33:51 +0100187 export ORIGIN=$(git config --get gitflow.origin || echo origin)
Vincent Driessend72e4ac2010-02-16 21:33:51 +0100188}
189
Vincent Driessend0991262010-02-06 21:19:07 +0100190#
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100191# gitflow_resolve_nameprefix
Vincent Driessend0991262010-02-06 21:19:07 +0100192#
193# Inputs:
194# $1 = name prefix to resolve
195# $2 = branch prefix to use
196#
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100197# Searches branch names from git_local_branches() to look for a unique
Vincent Driessen21c7aa92010-02-16 20:57:35 +0100198# branch name whose name starts with the given name prefix.
Vincent Driessend0991262010-02-06 21:19:07 +0100199#
200# There are multiple exit codes possible:
201# 0: The unambiguous full name of the branch is written to stdout
202# (success)
203# 1: No match is found.
204# 2: Multiple matches found. These matches are written to stderr
205#
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100206gitflow_resolve_nameprefix() {
Vincent Driessenf46e2902010-02-15 23:01:52 +0100207 local name=$1
208 local prefix=$2
209 local matches
210 local num_matches
Vincent Driessend0991262010-02-06 21:19:07 +0100211
212 # first, check if there is a perfect match
Vincent Driessen5b05ad72010-05-27 11:51:50 -0700213 if git_local_branch_exists "$prefix$name"; then
Vincent Driessend0991262010-02-06 21:19:07 +0100214 echo "$name"
215 return 0
216 fi
217
Vincent Driessen1b471a62011-02-04 08:25:38 +0100218 matches=$(echo "$(git_local_branches)" | grep "^$(escape "$prefix$name")")
Vincent Driessend0991262010-02-06 21:19:07 +0100219 num_matches=$(echo "$matches" | wc -l)
220 if [ -z "$matches" ]; then
221 # no prefix match, so take it literally
222 warn "No branch matches prefix '$name'"
223 return 1
224 else
225 if [ $num_matches -eq 1 ]; then
226 echo "${matches#$prefix}"
227 return 0
228 else
229 # multiple matches, cannot decide
230 warn "Multiple branches match prefix '$name':"
231 for match in $matches; do
232 warn "- $match"
233 done
234 return 2
235 fi
236 fi
237}
238
Vincent Driessen55c15532010-02-22 07:28:27 +0100239#
240# Assertions for use in git-flow subcommands
241#
Vincent Driessenc3607ac2010-02-05 19:53:45 +0100242
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100243require_git_repo() {
Vincent Driessend72e4ac2010-02-16 21:33:51 +0100244 if ! git rev-parse --git-dir >/dev/null 2>&1; then
Vincent Driessenc1598bf2010-02-20 16:52:48 +0100245 die "fatal: Not a git repository"
246 fi
247}
248
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100249require_gitflow_initialized() {
Vincent Driessenc1598bf2010-02-20 16:52:48 +0100250 if ! gitflow_is_initialized; then
251 die "fatal: Not a gitflow-enabled repo yet. Please run \"git flow init\" first."
Vincent Driessend72e4ac2010-02-16 21:33:51 +0100252 fi
253}
254
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100255require_clean_working_tree() {
256 git_is_clean_working_tree
Vincent Driessenf46e2902010-02-15 23:01:52 +0100257 local result=$?
Vincent Driessenc3607ac2010-02-05 19:53:45 +0100258 if [ $result -eq 1 ]; then
259 die "fatal: Working tree contains unstaged changes. Aborting."
260 fi
261 if [ $result -eq 2 ]; then
262 die "fatal: Index contains uncommited changes. Aborting."
263 fi
264}
265
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100266require_local_branch() {
Vincent Driessen6ee62232010-02-22 07:45:24 +0100267 if ! git_local_branch_exists $1; then
Vincent Driessenc3607ac2010-02-05 19:53:45 +0100268 die "fatal: Local branch '$1' does not exist and is required."
269 fi
270}
271
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100272require_remote_branch() {
273 if ! has $1 $(git_remote_branches); then
Vincent Driessenc3607ac2010-02-05 19:53:45 +0100274 die "Remote branch '$1' does not exist and is required."
275 fi
276}
277
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100278require_branch() {
279 if ! has $1 $(git_all_branches); then
Vincent Driessenc3607ac2010-02-05 19:53:45 +0100280 die "Branch '$1' does not exist and is required."
281 fi
282}
283
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100284require_branch_absent() {
285 if has $1 $(git_all_branches); then
Vincent Driessenc3607ac2010-02-05 19:53:45 +0100286 die "Branch '$1' already exists. Pick another name."
287 fi
288}
289
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100290require_tag_absent() {
291 if has $1 $(git_all_tags); then
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100292 die "Tag '$1' already exists. Pick another name."
293 fi
294}
295
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100296require_branches_equal() {
297 require_local_branch "$1"
298 require_remote_branch "$2"
299 git_compare_branches "$1" "$2"
Vincent Driessenf46e2902010-02-15 23:01:52 +0100300 local status=$?
Vincent Driessenc3607ac2010-02-05 19:53:45 +0100301 if [ $status -gt 0 ]; then
302 warn "Branches '$1' and '$2' have diverged."
303 if [ $status -eq 1 ]; then
304 die "And branch '$1' may be fast-forwarded."
305 elif [ $status -eq 2 ]; then
306 # Warn here, since there is no harm in being ahead
307 warn "And local branch '$1' is ahead of '$2'."
308 else
309 die "Branches need merging first."
310 fi
311 fi
312}